#include <stdio.h>
#include "rs232.h"

unsigned char testdata=0;
unsigned char testdatainit=0;

main(int argc, char **argv)
{
int c;
    if (argc<2) {
	printf("Usage: PASSTEST <comport>\n");
        return(-1);
    }
    if (atoi(argv[1])<=0) {
	printf("Illegal comport.  Legal values are 1-4.\n");
	return(-2);
    }
    InitComm(atoi(argv[1])-1,38400UL);
    MyWriteChar('L');
    MyWriteChar('I');
    MyWriteChar('N');
    MyWriteChar('C');
    MyWriteChar('B');
    MyWriteChar(0xE1);
    MyWriteChar(0x0E);
    MyWriteChar(0xB5);
    MyWriteChar(((0xE1+0x0E+0xB5+'L'+'I'+'N'+'C'+'B')&0xFF)); 
    MyWriteChar(0xFF-((0xE1+0x0E+0xB5+'L'+'I'+'N'+'C'+'B')&0xFF)); 
    printf("Command to go to pass through mode sent.\n");
    InitComm(atoi(argv[1])-1,9600UL);
    printf("Press ESC to quit.\n");
    printf("Press F1 to send break or F2 to send continuous stream or\n");
    printf("Press F3 to receive a continuous stream.\n");
    printf("Press F4 to send FC.\n");
    while (1) {
	if (kbhit()) {
	    if ((c=getch())==27) {
		printf("\nTerminating.\n");
		exit(0);
	    }
	    if (!c) {
		c=getch();
		if ((c>=59)&&(c<=62)) {
		    if (c==59) {
			SendBreak();
			printf("(BREAK)");
		    } else if (c==60) {
			printf("\nTransmitting continuous stream...");
			while (1) {
			    if (kbhit()) {
			        if ((c=getch())==27) {
				   printf("\nTerminating.\n");
				   exit(0);
			        } else if (!c) getch();
			    }
			    MyWriteChar(testdata++);
			    if (!testdata) printf(".");
			}
		    } else if (c==61) {
			printf("\nReceiving continuous stream...");
			testdatainit=0;
			while (testdatainit!=2) {
			    if (kbhit()) {
			        if ((c=getch())==27) {
				    printf("\nTerminating.\n");
				    exit(0);
			        } else if (!c) getch();
			    }
		            if (MyReadCharPending()==0) {
				c=MyReadChar();
				if (testdatainit==0) {
				    testdatainit=1;
				    testdata=c;
				} else {
				    testdata++;
				    if (testdata!=c) {
					printf("\nReceived mismatch "
					    "expected %d received %d!\n",
					    testdata,c);
					testdatainit=2;
				    } else {
					if (!testdata) printf(".");
				    }
			  	}
       			    }
			}
		    } else if (c==62) {
			MyWriteChar(0xFC);
			printf("<FC>");
		    }
		}
	    } else {
		MyWriteChar(c);
		printf("(%c)",c);
	    }
       }
       if (MyReadCharPending()==0) {
	   if (BreakPending()==0) {
	       printf("<BREAK>");
           } else {		
               printf("%c",MyReadChar());
	   }
       }
       if (BreakPending()==0) {
	   printf("<BREAK>");
       }		
    }
    return(0);
}
    
void clean(int x)
{
    exit(x);
}

