Option Strict Off
Option Explicit On
Module MainModLINRS232
	'Global quicker As Boolean '1.6
	Public ReceiveBufferOverflowOccurred(16) As Boolean '2.0.6
	Public ClearBufferOccurred(16) As Boolean '2.0.6
	Public ClearBufferTimestamp(16) As Short '2.0.6
	Public wakeupenabled As Boolean '1.6
	Public logging As Boolean
	Public logfilesize As Integer
	Public inAddText As Boolean
	Public ErrorCode As Short
	Public Ack_Received As Byte
	Public RecvGot As Short
	Public GotMismatch As Boolean
	Public MismatchError As Boolean
	Public RecvError As Boolean
	Public Repeat_ID As Short
	Public Repeat_ID2 As Short
	Public BadChecksum As Boolean
	Public NoResponse As Boolean '1.2
	Public Repeat2 As Boolean '1.2
	Public Waiting As Boolean
	Public LIN20 As Boolean '2.0
	Public ExtendedWakeup As Boolean
	Public sStr As String
	Public BaudRate As Integer
	Public WakeupMode As Boolean
	Public SlaveMode As Boolean
	Public Message As String
	Public HexNum As Short
    Public TimeVal As Short
    Public FastRepeatInterval As Short
	Public Quit As Boolean
	Public Loaded As Boolean
	Public SendSettings As Boolean
	Public SelectedNode As Short
	Public Selected_Message As Short
	Public Number_of_Messages As Short
	Public Number_of_Ports As Short
	Public PortNum(50) As Short
	Public in_background As Boolean
	Public RecvMismatchInit(16) As Boolean
	Public RecvExpected(16) As Short
	Public swallowcount(16) As Short
	Public recvstr(16) As String
	Public recvstate(16) As Short
	Public recvcks(16) As Short
	Public recvID(16) As Short
	Public recvdatastr(16) As String
	Public datafield1(16) As Short
	Public datafield2(16) As Short
	Public datafield3(16) As Short
	Public datafield4(16) As Short
	Public HundredMsec As Short
	Public PendingAck As Short
    Public WaitPendingAck As Boolean
    Public goodport(256) As Boolean
	
	Public Const MAX_BAUD As Short = 20000
	Public Const MIN_BAUD As Short = 1000
	
	Public Const CLEAR_RECEIVE_BUFFER As Short = &H81s
	Public Const SEND_WAKEUP_SIGNAL As Short = &H82s
	Public Const QUERY_STATUS As Short = &H83s
	Public Const QUERY_REVISION As Short = &H84s
	
	Public Const SET_WAKEUP_PENDING As Short = &H91s
	Public Const SET_LIN_BUS_BAUD_RATE As Short = &H92s
	Public Const SET_WAKEUPS_ENABLED As Short = &H93s
	Public Const SET_LIN_PROTOCOL As Short = &H94s '2.0
	Public Const SET_EXTENDED_WAKEUP As Short = &H95s
    Public Const SET_MASTER_SLAVE_MODE As Short = &H96S
    Public Const SET_FAST_REPEAT_INTERVAL As Short = &H97S
    Public Const SET_FAST_REPEAT_MODE As Short = &H98S

	Public Const PASSWORD As Short = 0 'unused
	
	Public Sub SaveData()
		Dim i As Short
		On Error GoTo writeerror
		FileOpen(1, My.Application.Info.DirectoryPath & "\LIN.CFG", OpenMode.Output)
		On Error GoTo writeerror2
		PrintLine(1, VB6.Format(SelectedNode, "#0"))
		PrintLine(1, VB6.Format(Selected_Message, "#0"))
		PrintLine(1, VB6.Format(BaudRate, "#0"))
		If BadChecksum = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		If WakeupMode = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		If NoResponse = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		If Repeat2 = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		PrintLine(1, VB6.Format(Number_of_Ports, "#0"))
		For i = 1 To Number_of_Ports
			PrintLine(1, PortNum(i - 1))
		Next i
		If MismatchError = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		If RecvError = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		'If quicker = True Then
		'    Print #1, "1"
		'Else
		'    Print #1, "0"
		'End If
		If wakeupenabled = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		If LIN20 = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		If ExtendedWakeup = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
		If SlaveMode = True Then
			PrintLine(1, "1")
		Else
			PrintLine(1, "0")
		End If
        PrintLine(1, VB6.Format(FastRepeatInterval, "#0"))
        FileClose(1)
		Exit Sub
writeerror: 
		On Error Resume Next
		MsgBox("Error opening LIN.CFG for writing!")
		Exit Sub
writeerror2: 
		On Error Resume Next
		MsgBox("Error writing to LIN.CFG!")
		FileClose(1)
	End Sub
	Public Function Hexx(ByVal Value As Short) As String
		Dim HexStr As String
		HexStr = Hex(Value)
		While Len(HexStr) < 2
			HexStr = "0" & HexStr
		End While
		Hexx = HexStr
	End Function
	Public Sub RecvBackgroundTask()
		Dim i As Short
		If in_background = True Then
			Exit Sub
		End If
		in_background = True
		On Error GoTo comportclosed
		For i = 1 To Number_of_Ports
            If GetPort(i - 1).ReadBufferSize = GetPort(i - 1).BytesToRead Then
                Add_Text(PortNum(i - 1), "PC Receive Buffer Overflow!")
                ReceiveBufferOverflowOccurred(i - 1) = True
                GetPort(i - 1).DiscardInBuffer()
                GetPort(i - 1).Close()
                GetPort(i - 1).Open()
            End If
			If Len(recvstr(i - 1)) > 0 Then
				If swallowcount(i - 1) > 0 Then
					swallowcount(i - 1) = swallowcount(i - 1) - 1
				Else
					Handle_Recv(i, Asc(Left(recvstr(i - 1), 1)))
				End If
				If Len(recvstr(i - 1)) > 1 Then
					recvstr(i - 1) = Right(recvstr(i - 1), Len(recvstr(i - 1)) - 1)
				Else
					recvstr(i - 1) = ""
				End If
			Else
				ReceiveBufferOverflowOccurred(i - 1) = False
				If (ClearBufferOccurred(i - 1) = True) Then
					'UPGRADE_WARNING: Couldn't resolve default property of object Elapsed(ClearBufferTimestamp(i - 1)). Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					If (Elapsed(ClearBufferTimestamp(i - 1)) > 20) Then
						ClearBufferOccurred(i - 1) = False
					End If
				End If
			End If
		Next i
		in_background = False
		On Error Resume Next
		Exit Sub
comportclosed: 
		On Error Resume Next
		Add_Text(PortNum(i - 1), "Trouble accessing COM port.")
	End Sub
	
	'UPGRADE_WARNING: Application will terminate when Sub Main() finishes. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="E08DDC71-66BA-424F-A612-80AF11498FF8"'
	Public Sub Main()
		Dim i As Short
		Quit = False
		For i = 0 To 15
			ReceiveBufferOverflowOccurred(i) = False
			ClearBufferOccurred(i) = False
		Next i
		fTop.Show()
		While Quit = False
			System.Windows.Forms.Application.DoEvents()
			RecvBackgroundTask()
		End While
		End
	End Sub
	Private Sub Handle_Recv(ByRef i As Short, ByRef RecvChar As Short)
		Dim j As Short
		Dim lincks As Short
		If (recvstate(i - 1) And 128) = 0 Then
			'header not received yet
			If RecvChar = Asc(Mid("RESP:", recvstate(i - 1) + 1, 1)) Then
goth: Update_Cks(i, RecvChar)
				If recvstate(i - 1) >= 4 Then
					recvstate(i - 1) = 128
				Else
					recvstate(i - 1) = recvstate(i - 1) + 1
				End If
			Else
				recvstate(i - 1) = 0
				recvcks(i - 1) = 0
				If RecvChar = Asc("R") Then
					GoTo goth
				Else
					If RecvChar > 0 Then '1.5 0 is okay if buffer overflowed
						Add_Text(PortNum(i - 1), "RX: BAD CHAR " & Hexx(RecvChar) & " (" & Chr(RecvChar) & ")!")
						If ReceiveBufferOverflowOccurred(i - 1) = True Then
							Add_Text(PortNum(i - 1), "(BUT THAT IS PROBABLY BECAUSE THE SERIAL RECEIVE BUFFER OVERFLOWED)")
						End If
						If ClearBufferOccurred(i - 1) = True Then
							Add_Text(PortNum(i - 1), "(BUT THAT IS BECAUSE CLEAR BUFFERS OPERATION IS IN EFFECT AND BUFFER MAY HAVE BEEN CLEARED IN MIDDLE)")
						End If
					End If
					If RecvError = True Then
						StopRepeat()
					End If
				End If
			End If
		Else
			'header received
			Select Case (recvstate(i - 1) And 127)
				Case 0 'Recv ID
					recvID(i - 1) = RecvChar
					Update_Cks(i, RecvChar)
					Select Case RecvChar
						Case &H81s
							recvstate(i - 1) = 128 + 1
						Case &H82s
							recvstate(i - 1) = 128 + 2
						Case Else
							If RecvChar And &HC0s Then
								Add_Text(PortNum(i - 1), "RX: ILLEGAL ID " & Hex(RecvChar))
								If RecvError = True Then
									StopRepeat()
								End If
								recvstate(i - 1) = 0
								recvcks(i - 1) = 0
							Else
								recvdatastr(i - 1) = Chr(RecvChar)
								recvstate(i - 1) = 128 + 7
							End If
					End Select
				Case 1 'Recv Revision Level
					Update_Cks(i, RecvChar)
					recvdatastr(i - 1) = Chr(RecvChar)
					recvstate(i - 1) = 128 + 5
				Case 2 'Recv Status Code
					Update_Cks(i, RecvChar)
					recvdatastr(i - 1) = Chr(RecvChar)
					recvstate(i - 1) = 128 + 3
				Case 3 'Recv Bus Awake
					Update_Cks(i, RecvChar)
					recvdatastr(i - 1) = recvdatastr(i - 1) & Chr(RecvChar)
					recvstate(i - 1) = 128 + 4
				Case 4 'receive command ack
					Update_Cks(i, RecvChar)
					recvdatastr(i - 1) = recvdatastr(i - 1) & Chr(RecvChar)
					recvstate(i - 1) = 128 + 5
				Case 5 'Recv checksum #1
					If recvcks(i - 1) = RecvChar Then
						recvstate(i - 1) = 128 + 6
					Else
						If RecvChar Then '1.5: a 0 checksum happens when buffer overflows
							Add_Text(PortNum(i - 1), "RX: Bad checksum #1 from LIN Converter Box")
						End If
						If RecvError = True Then
							StopRepeat()
						End If
						recvstate(i - 1) = 0
						recvcks(i - 1) = 0
					End If
				Case 6 'Recv checksum #2
					If (255 - recvcks(i - 1)) = RecvChar Then
						If (recvID(i - 1) And (128 + 64)) = 0 Then
							sStr = ""
							lincks = 0
							For j = 2 To (Len(recvdatastr(i - 1)) - 1)
								lincks = lincks + Asc(Mid(recvdatastr(i - 1), j, 1))
								If lincks >= 256 Then lincks = lincks - 255
							Next j
							lincks = 255 - lincks
							GotMismatch = False
							For j = 1 To (Len(recvdatastr(i - 1)) - 1)
								RecvGot = Asc(Mid(recvdatastr(i - 1), j, 1))
								If RecvMismatchInit(i - 1) = False Then
									RecvExpected(i - 1) = RecvGot
									RecvMismatchInit(i - 1) = True
								Else
									RecvExpected(i - 1) = RecvExpected(i - 1) + 1
									If RecvExpected(i - 1) > &H3Fs Then
										RecvExpected(i - 1) = 0
									End If
									If RecvGot <> RecvExpected(i - 1) Then
										GotMismatch = True
									End If
								End If
								sStr = sStr & Hexx(Asc(Mid(recvdatastr(i - 1), j, 1))) & " "
							Next j
							lincks = 0
							For j = 2 To (Len(recvdatastr(i - 1)) - 1)
								lincks = lincks + Asc(Mid(recvdatastr(i - 1), j, 1))
								If lincks >= 256 Then lincks = lincks - 255
							Next j
							lincks = 255 - lincks
							If lincks = Asc(Right(recvdatastr(i - 1), 1)) Then
								sStr = sStr & "LIN 1.3 CKS OK"
							Else
								lincks = recvID(i - 1) Or &H80s
								If ((lincks And 1) = 1) Then lincks = lincks Xor &H40s
								If ((lincks And 2) = 2) Then lincks = lincks Xor &HC0s
								If ((lincks And 4) = 4) Then lincks = lincks Xor &H40s
								If ((lincks And 8) = 8) Then lincks = lincks Xor &H80s
								If ((lincks And &H10s) = &H10s) Then lincks = lincks Xor &HC0s
								If ((lincks And &H20s) = &H20s) Then lincks = lincks Xor &H80s
								For j = 2 To (Len(recvdatastr(i - 1)) - 1)
									lincks = lincks + Asc(Mid(recvdatastr(i - 1), j, 1))
									If lincks >= 256 Then lincks = lincks - 255
								Next j
								lincks = 255 - lincks
								If lincks = Asc(Right(recvdatastr(i - 1), 1)) Then
									sStr = sStr & "LIN 2.0 CKS OK"
								Else
									If Len(recvdatastr(i - 1)) >= 2 Then
										sStr = sStr & "LIN CKS BAD"
									Else
										sStr = Hexx(recvID(i - 1)) & " SLAVE NOT RESPONDING"
									End If
									If BadChecksum = True Or RecvError = True Then
										StopRepeat()
									End If
								End If
							End If
							Add_Text(PortNum(i - 1), "RX: " & sStr)
							If GotMismatch = True And MismatchError = True Then
                                Add_Text(PortNum(i - 1), "RX: Mismatch Error")
								RecvMismatchInit(i - 1) = False
								StopRepeat()
							End If
						Else
							If recvID(i - 1) = &H81s Then
								Add_Text(PortNum(i - 1), "RX: Revision Level" & Str(Asc(recvdatastr(i - 1))))
								Ack_Received = QUERY_REVISION
							Else
								If recvID(i - 1) = &H82s Then
									Ack_Received = Asc(Right(recvdatastr(i - 1), 1))
									ErrorCode = Asc(Left(recvdatastr(i - 1), 1))
									If ErrorCode = &H4Fs Then
										Select Case Asc(Right(recvdatastr(i - 1), 1))
											Case &H81s : Add_Text(PortNum(i - 1), "RX: Ack Clear Receive Buffer; Buffer Cleared")
											Case &H82s : Add_Text(PortNum(i - 1), "RX: Ack Send Wake-Up Signal; Wake-Up Sent")
											Case &H83s : Add_Text(PortNum(i - 1), "RX: Ack Query Status; LIN Box is Okay")
											Case &H91s : Add_Text(PortNum(i - 1), "RX: Ack Set Wake-Up Pending")
											Case &H92s : Add_Text(PortNum(i - 1), "RX: Ack Set LIN Bus Baud Rate")
											Case &H93s : Add_Text(PortNum(i - 1), "RX: Ack Set Wake-Up Enable")
											Case &H94s : Add_Text(PortNum(i - 1), "RX: Ack Set LIN Protocol")
											Case &H95s : Add_Text(PortNum(i - 1), "RX: Ack Set Extended Wakeups")
                                            Case &H96S : Add_Text(PortNum(i - 1), "RX: Ack Set Master/Slave Mode")
                                            Case &H97S : Add_Text(PortNum(i - 1), "RX: Ack Set Fast Reepeat Interval")
                                            Case &H98S : Add_Text(PortNum(i - 1), "RX: Ack Set Fast Reepeat Mode")
                                            Case Else
                                                If Asc(Right(recvdatastr(i - 1), 1)) < &H40S Then
                                                    Add_Text(PortNum(i - 1), "Ack Message " & Hex(Asc(Right(recvdatastr(i - 1), 1))) & "; LIN Box is Okay")
                                                    If WaitPendingAck = True Then
                                                        If PendingAck = Asc(Right(recvdatastr(i - 1), 1)) Then
                                                            WaitPendingAck = False
                                                        End If
                                                    End If
                                                Else
                                                    Add_Text(PortNum(i - 1), "Ack Unknown Command " & Hex(Asc(Right(recvdatastr(i - 1), 1))) & "; LIN Box is Okay")
                                                End If
                                        End Select
									Else
										DisplayErrorCode(i - 1)
										If ErrorCode = 6 And NoResponse = True Then
											StopRepeat()
										End If
										If RecvError = True Then
											StopRepeat()
										End If
									End If
									'If Asc(Right$(recvdatastr(i - 1), 1)) = 0 Then
									'    Add_Text PortNum(i - 1), "RX: Bus was asleep."
									'Else
									'    Add_Text PortNum(i - 1), "RX: Bus was awake."
									'End If
								End If
							End If
						End If
					Else
						Add_Text(PortNum(i - 1), "RX: Bad checksum #2 from LIN Converter Box")
						If RecvError = True Then
							StopRepeat()
						End If
					End If
					recvstate(i - 1) = 0
					recvcks(i - 1) = 0
				Case 7 'recv data #1
					Update_Cks(i, RecvChar)
					datafield1(i - 1) = RecvChar
					recvstate(i - 1) = 128 + 8
				Case 8 'recv data #2
					Update_Cks(i, RecvChar)
					datafield2(i - 1) = RecvChar
					recvstate(i - 1) = 128 + 9
				Case 9 'recv data #3
					Update_Cks(i, RecvChar)
					datafield3(i - 1) = RecvChar
					recvstate(i - 1) = 128 + 10
				Case 10 'recv data #4
					Update_Cks(i, RecvChar)
					datafield4(i - 1) = RecvChar
					recvstate(i - 1) = 128 + 11
				Case 11 'recv length/continuation indicator
					Update_Cks(i, RecvChar)
					Select Case RecvChar
						Case 0 'end of message
							recvstate(i - 1) = 128 + 5
						Case 1 '1 byte and end of message
							recvdatastr(i - 1) = recvdatastr(i - 1) & Chr(datafield1(i - 1))
							recvstate(i - 1) = 128 + 5
						Case 2 '2 bytes and end of message
							recvdatastr(i - 1) = recvdatastr(i - 1) & Chr(datafield1(i - 1)) & Chr(datafield2(i - 1))
							recvstate(i - 1) = 128 + 5
						Case 3 '3 bytes and end of message
							recvdatastr(i - 1) = recvdatastr(i - 1) & Chr(datafield1(i - 1)) & Chr(datafield2(i - 1)) & Chr(datafield3(i - 1))
							recvstate(i - 1) = 128 + 5
						Case 4 '4 bytes and end of message
							recvdatastr(i - 1) = recvdatastr(i - 1) & Chr(datafield1(i - 1)) & Chr(datafield2(i - 1)) & Chr(datafield3(i - 1)) & Chr(datafield4(i - 1))
							recvstate(i - 1) = 128 + 5
						Case &H88s 'Frame Error
							Add_Text(PortNum(i - 1), "RX: Frame Error during Reception (9-11 bit frame).")
							If RecvError = True Then
								StopRepeat()
							End If
							swallowcount(i - 1) = 2
							recvstate(i - 1) = 0
							recvcks(i - 1) = 0
						Case &HFFs '4 bytes and continuation
							recvdatastr(i - 1) = recvdatastr(i - 1) & Chr(datafield1(i - 1)) & Chr(datafield2(i - 1)) & Chr(datafield3(i - 1)) & Chr(datafield4(i - 1))
							recvstate(i - 1) = 128 + 7
						Case Else
							Add_Text(PortNum(i - 1), "Received illegal length indicator " & Hex(RecvChar))
							If ReceiveBufferOverflowOccurred(i - 1) = True Then
								Add_Text(PortNum(i - 1), "(BUT THAT IS PROBABLY BECAUSE THE SERIAL RECEIVE BUFFER OVERFLOWED)")
							End If
							If ClearBufferOccurred(i - 1) = True Then
								Add_Text(PortNum(i - 1), "(BUT THAT IS BECAUSE CLEAR BUFFERS OPERATION IS IN EFFECT AND BUFFER MAY HAVE BEEN CLEARED IN MIDDLE)")
							End If
							If RecvError = True Then
								StopRepeat()
							End If
							recvstate(i - 1) = 0
							recvcks(i - 1) = 0
					End Select
				Case Else
					MsgBox("Illegal recvstate(" & VB6.Format(i - 1, "#0") & ")=" & VB6.Format(recvstate(i - 1), "#0"))
					recvstate(i - 1) = 0
					recvcks(i - 1) = 0
					If RecvError = True Then
						StopRepeat()
					End If
			End Select
		End If
	End Sub
	
	'UPGRADE_NOTE: val was upgraded to val_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
	Public Sub Update_Cks(ByRef i As Short, ByRef val_Renamed As Short)
		recvcks(i - 1) = recvcks(i - 1) + val_Renamed
		If recvcks(i - 1) >= 256 Then recvcks(i - 1) = recvcks(i - 1) - 256
	End Sub
	

    Public Sub Add_Text(ByVal COMportnum As Integer, ByVal sStr As String)
        Dim pos As Long
        inAddText = True
        If logging = True Then
            On Error GoTo badsave
            logfilesize = logfilesize + 9 + Len(TimeString) + Len(sStr)
            PrintLine(2, TimeString + " COM" + Format(COMportnum, "#0") + ": " + sStr)
            GoTo donewithsave
badsave:
            On Error Resume Next
            MsgBox("Error Saving to Log File!  Saved " & VB6.Format(logfilesize, "#0") & " bytes already.", MsgBoxStyle.Critical, "Error")
            On Error GoTo badclose
            FileClose(2)
            GoTo donewithsave
badclose:
            On Error Resume Next
            MsgBox("Error closing Log File!", MsgBoxStyle.Critical, "Error")
            GoTo donewithsave
donewithsave:
        End If
        On Error GoTo noroom
        If Len(fTop.tTerminalWindow.Text) + Len(sStr) + Len(TimeString) + 9 + 2 > fTop.tTerminalWindow.MaxLength Then
            GoTo noroom
        End If
        fTop.tTerminalWindow.Text = fTop.tTerminalWindow.Text + TimeString + " COM" + Format(COMportnum, "#0") + ": " + sStr + Chr(13) + Chr(10)
        fTop.tTerminalWindow.SelectionStart = Len(fTop.tTerminalWindow.Text) - 1
        fTop.tTerminalWindow.SelectionLength = 0 'forces cursor to end of text
        fTop.tTerminalWindow.ScrollToCaret()
        On Error Resume Next
        inAddText = False
        Exit Sub
noroom:
        pos = Len(fTop.tTerminalWindow.Text) / 8
        If pos <= Len(fTop.tTerminalWindow.Text) Then
            fTop.tTerminalWindow.Text = Right(fTop.tTerminalWindow.Text, (Len(fTop.tTerminalWindow.Text) - pos) + 1)
            fTop.tTerminalWindow.Text = fTop.tTerminalWindow.Text & TimeString & ": " & sStr & Chr(13) & Chr(10)
        Else
            fTop.tTerminalWindow.Text = TimeString & ": " & sStr & Chr(13) & Chr(10)
        End If
        fTop.tTerminalWindow.SelectionStart = Len(fTop.tTerminalWindow.Text) - 1
        fTop.tTerminalWindow.SelectionLength = 0 'forces cursor to end of text
        fTop.tTerminalWindow.ScrollToCaret()
        On Error Resume Next
        inAddText = False
    End Sub
    Public Function GetPort(ByVal i As Short) As System.IO.Ports.SerialPort
        Select Case i
            Case 0 : GetPort = fTop.comPort0
            Case 1 : GetPort = fTop.comPort1
            Case 2 : GetPort = fTop.comPort2
            Case 3 : GetPort = fTop.comPort3
            Case 4 : GetPort = fTop.comPort4
            Case 5 : GetPort = fTop.comPort5
            Case 6 : GetPort = fTop.comPort6
            Case 7 : GetPort = fTop.comPort7
            Case 8 : GetPort = fTop.comPort8
            Case 9 : GetPort = fTop.comPort9
            Case 10 : GetPort = fTop.comPort10
            Case 11 : GetPort = fTop.comPort11
            Case 12 : GetPort = fTop.comPort12
            Case 13 : GetPort = fTop.comPort13
            Case 14 : GetPort = fTop.comPort14
            Case Else : GetPort = fTop.comPort15
        End Select
    End Function
    Public Sub StopRepeat()
        Dim i As Short
        If Repeat_ID <> 0 Then
            Repeat_ID = 0
            If Repeat_ID2 <> 0 Then
                Repeat_ID2 = 0
                fTop.bRepeat.Text = "Send Selected Messages Repeatedly"
            Else
                fTop.bRepeat.Text = "Send Selected Message Repeatedly"
            End If
            For i = 0 To 15
                RecvMismatchInit(i) = False
            Next i
            fTop.bRepeat.Enabled = True
        End If
    End Sub

    Public Sub DisplayErrorCode(ByRef nodeidx As Short)
        Dim i As Short
        i = PortNum(nodeidx)
        Select Case ErrorCode
            Case &H0S : Add_Text(i, "RX: Bit Error (Failed to assert LIN line low).")
            Case &H1S : Add_Text(i, "RX: Identifier Parity Error during Reception.")
            Case &H2S : Add_Text(i, "RX: Inconsistent Synch Field during Reception.")
            Case &H3S : Add_Text(i, "RX: Frame Error during Reception (9-11 bit frame).")
            Case &H4S : Add_Text(i, "RX: Lost Arbitration (Failed to set LIN line high or lost arbitration or bus shorted to ground).")
            Case &H5S : Add_Text(i, "RX: Received Illegal Data while LIN Bus Was Asleep.")
            Case &H6S : Add_Text(i, "RX: Slave not responding.")
            Case &H20S : Add_Text(i, "RX: Received invalid checksum from PC.")
            Case &H21S : Add_Text(i, "RX: Received invalid command from PC.")
            Case &H22S : Add_Text(i, "RX: Command not allowed in Fast Repeat mode.")
            Case &H30S : Add_Text(i, "RX: Receive (from PC to LIN box) buffer overflow.")
            Case &H31S : Add_Text(i, "RX: Transmit (from LIN box to PC) buffer overflow.")
            Case &H4FS : Add_Text(i, "RX: LIN Box status OK.")
            Case &H50S : Add_Text(i, "RX: LIN Bus Transmit Overflow (from PC to LIN bus).")
            Case &H51S : Add_Text(i, "RX: LIN Bus Receive Overflow (from LIN bus to PC).")
            Case &HE0S : Add_Text(i, "RX: FLASH ROM Checksum Error.")
            Case &HFFS : Add_Text(i, "RX: Error communicating with LIN box.")
            Case Else : Add_Text(i, "RX: LIN Box returned error code " & Hex(ErrorCode) & "H")
        End Select
    End Sub


    Public Function Elapsed(ByRef TimeStamp As Short) As Short
        Dim TimeElapsed As Short
        If (TimeStamp > HundredMsec) Then
            TimeElapsed = (32767 - TimeStamp) + HundredMsec
        Else
            TimeElapsed = HundredMsec - TimeStamp
        End If
        'UPGRADE_WARNING: Couldn't resolve default property of object Elapsed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        Elapsed = TimeElapsed
    End Function
End Module